#include "DFRobot_OLED12864.h"
#include <hidboot.h>
#include <usbhub.h>
#include <SPI.h>

const uint8_t I2C_addr = 0x3c;
const uint8_t pin_SPI_cs = D2;

DFRobot_OLED12864 OLED(I2C_addr, pin_SPI_cs);

USB     Usb;
USBHub     Hub(&Usb);
HIDBoot<USB_HID_PROTOCOL_MOUSE>    HidMouse(&Usb);


class MouseRptParser : public MouseReportParser
{
protected:
  void OnMouseMove  (MOUSEINFO *mi);
  void OnLeftButtonUp (MOUSEINFO *mi);
  void OnLeftButtonDown (MOUSEINFO *mi);
  void OnRightButtonUp  (MOUSEINFO *mi);
  void OnRightButtonDown  (MOUSEINFO *mi);
  void OnMiddleButtonUp (MOUSEINFO *mi);
  void OnMiddleButtonDown (MOUSEINFO *mi);
};
void MouseRptParser::OnMouseMove(MOUSEINFO *mi)
{
    char str[14];
    
    sprintf(str, "x=%d y=%d    ", mi->dX,mi->dY);
    OLED.disStr(0, 16, (char *)str);
    OLED.display();

    Serial.print("dx=");
    Serial.print(mi->dX, DEC);
    Serial.print(" dy=");
    Serial.println(mi->dY, DEC);
    Serial.println(str);
};
void MouseRptParser::OnLeftButtonUp (MOUSEINFO *mi)
{
    Serial.println("L Butt Up");

    OLED.disStr(0, 32, "L Butt Up   ");
    OLED.display();
};
void MouseRptParser::OnLeftButtonDown (MOUSEINFO *mi)
{
    Serial.println("L Butt Dn");
    OLED.disStr(0, 32, "L Butt Dn  ");
    OLED.display();    
};
void MouseRptParser::OnRightButtonUp  (MOUSEINFO *mi)
{
    Serial.println("R Butt Up");
    OLED.disStr(0, 32, "R Butt Up   ");
    OLED.display();    
};
void MouseRptParser::OnRightButtonDown  (MOUSEINFO *mi)
{
    Serial.println("R Butt Dn");
    OLED.disStr(0, 32, "R Butt Un   ");
    OLED.display();    
};
void MouseRptParser::OnMiddleButtonUp (MOUSEINFO *mi)
{
    Serial.println("M Butt Up");
    OLED.disStr(0, 32, "M Butt Up   ");
    OLED.display();    
};
void MouseRptParser::OnMiddleButtonDown (MOUSEINFO *mi)
{
    Serial.println("M Butt Dn");
    OLED.disStr(0, 32, "M Butt Up   ");
    OLED.display();    
};

MouseRptParser                               Prs;


void setup(void)
{
  Serial.begin(115200);
  OLED.init();
  OLED.flipScreenVertically();

    if (Usb.Init() == -1)
        Serial.println("OSC did not start.");

    delay( 200 );

    HidMouse.SetReportParser(0, &Prs);

    OLED.disStr(0, 0, "Mouse测试");
    OLED.display();
}


void loop(void)
{

    Usb.Task();
    

}    
